<?php
/**
 *
 * @category        modules
 * @package         minigallery
 * @author          Ruud Eisinga
 * @link			http://www.allwww.nl/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.x
 * @requirements    PHP 5.2.2 and higher
 * @version         0.2
 * @lastmodified    19 aug 2011
 *
 */
if(defined('WB_PATH') == false) { exit("Cannot access this file directly"); }
if(!file_exists(WB_PATH.'/modules/miniform/languages/'.LANGUAGE.'.php')) {
	require_once(WB_PATH.'/modules/miniform/languages/EN.php');
} else {
	require_once(WB_PATH.'/modules/miniform/languages/'.LANGUAGE.'.php');
}
require_once ('functions.php');
$mf = new mform();

$get_settings = $database->query("SELECT * FROM ".TABLE_PREFIX."mod_miniform WHERE section_id = '$section_id'");
$settings = $get_settings->fetchRow();
$form = $settings['template'];
$email = $settings['email'];
$subject = $settings['subject'];
$successpage = $settings['successpage'];
$message = "";
$message_class = "hidden";
$form_class = "";

if ( isset($_POST) && is_array($_POST) && count($_POST) > 0 ) { 
	$mailmessage = $mf->get_template('email');
	$mailmessage = $mf->add_template($mailmessage, "{SUBJECT}", $subject);
	$field_val = $mf->get_template('email_field_value');
	$tmp_fv = '';
	$all_required = true;
	foreach ($_POST as $key => $rawpost) {
		$post = $mf->safe_get_post($key);
		$required = false;
		$mailmessage = $mf->add_template($mailmessage, '{'.strtoupper($key).'}', $post);
		if(substr($key,0,3)=="mf_") {
			$key =  substr($key,3);
			if (substr($key,0,2)=="r_") {
				$required = true;
				$key =  substr($key,2);
			}
			$var[] = "{".strtoupper($key)."}"; $value[] = $post;
			$var[] = "{".strtoupper($key.'_'.$post)."}"; $value[] = " checked='checked' ";
			if($required && trim($post) == '') {
				$var[] = "{".strtoupper($key)."_ERROR}"; $value[] = " missing";
				$all_required = false;
			}
			$key = ucwords($key);
			$key = str_replace("_"," ",$key);
			$post = nl2br($post);
			if($post) {
				$tmp_fv .= $mf->add_template($field_val, array('{FIELD}','{VALUE}'), array($key,$post));
			}
		}
	}
	$mailmessage = $mf->add_template($mailmessage, '{MAILMESSAGE}', $tmp_fv);
	if ($all_required) {
		// store message in database
		$data['message_id'] = 0;
		$data['section_id'] = $section_id;
		$data['data'] = addslashes($mailmessage); 
		$data['submitted_when'] = time();
		$mf->update_record('mod_miniform_data', 'message_id', $data );
		// send message by mail
		if($mf->mail ($email, $email, $subject, $mailmessage)) {
			if($successpage) {
				$page_link = $mf->page($successpage);
				if(headers_sent()) {
					echo '<script type="text/javascript">window.location = "'.$page_link.'"</script>';
				} else {
					die(header('Location: '.$page_link , TRUE , 301));
				}
			}
			$message = $MF['THANKYOU'];
			$message_class = "ok";
			$form_class = "hidden";
		}
	} else {
		$message = $MF['NOTALL'];
		$message_class = "error";
	}
}

$template = $mf->get_template('form_'.$form);
$var[] = "{STATUSMESSAGE}";	$value[] = $message;
$var[] = "{MESSAGE_CLASS}";	$value[] = $message_class;
$var[] = "{FORM_CLASS}";	$value[] = $form_class;
$var[] = "{PAGE_ID}";	$value[] = $page_id;
$var[] = "{SECTION_ID}";$value[] = $section_id;
$var[] = "{DATE}";$value[] = date( DATE_FORMAT , time()+TIMEZONE );
$var[] = "{TIME}";$value[] = date( TIME_FORMAT , time()+TIMEZONE );
$template = $mf->add_template($template, $var, $value);

//clean unused fields in the template
$template = preg_replace('#\{[A-Za-z_][A-Za-z_0-9]*?\}#s', '', $template); 
echo $template;

